diff -Ncr linux-2.4.20-aralion-0.0/drivers/scsi/ultimaraid133/ultima.h linux-2.4.20-aralion-0.1/drivers/scsi/ultimaraid133/ultima.h
*** linux-2.4.20-aralion-0.0/drivers/scsi/ultimaraid133/ultima.h	1970-01-01 09:00:00.000000000 +0900
--- linux-2.4.20-aralion-0.1/drivers/scsi/ultimaraid133/ultima.h	2003-11-26 16:30:31.000000000 +0900
***************
*** 0 ****
--- 1,239 ----
+ #ifndef _ULTIMA_H
+ #define _ULTIMA_H
+ #include <linux/kdev_t.h>
+ 
+ #ifndef UCHAR 
+ #define UCHAR 	unsigned char
+ #define USHORT	unsigned short
+ #define	ULONG	unsigned long
+ #define DWORD	unsigned long
+ #define BYTE	unsigned char
+ #define	WORD	unsigned short
+ #endif 
+ 
+ #define		ARALION_VENDOR		0x1538
+ #define		ULTIMA_DEVICE		0x0303
+ 
+ #define		READ_STATUS			0x10000000
+ #define		WRITE_STATUS		0x20000000
+ #define		RESET_STATUS		0x40000000
+ #define 	REBUILD_STATUS		0x80000000
+ #define		MIRRORWRITE_STATUS	0x01000000
+ /*
+ #define 	ORDER_FIRST			0x00000001
+ #define 	ORDER_LAST			0x00000010
+ */
+ 
+ #define 	ORDER_ONE			0x00000001
+ #define 	ORDER_TWO			0x00000010
+ #define 	ORDER_THREE			0x00000100
+ #define 	ORDER_FOUR			0x00001000
+ 
+ 
+ #define DataPort          		0x00
+ #define ErrorPort         		0x01
+ #define BlockCountPort    		0x02
+ #define BlockNumberPort   		0x03
+ #define CylinderLowPort   		0x04
+ #define CylinderHighPort  		0x05
+ #define DriveSelectPort   		0x06 
+ #define CommandPort       		0x07   
+ #define AlternateStatusPort 	0x0E
+ 
+ #define FLASH_ADDRESS			0x02
+ #define FLASH_COMMAND			0x04
+ #define FLASH_STATUS			0x06
+ 
+ #define	SCATTERLISTSIZE			4096
+ 
+ #define	NODISK						0x00000000
+ #define NORMALIDE					0x00000001
+ #define STRIPING_2S					0x00000002
+ #define STRIPING_4S					0x00000003
+ #define MIRRORING					0x00000004
+ #define STRIPMIRRORING_2S			0x00000005
+ #define STRIPMIRRORING_4S			0x00000006
+ #define JBOD						0x00000007
+ //#define STRIPMIRRORING2				
+ 
+ #define NOTAVAILABLE				0x0000ffff
+ #define	ERROR_INVALID_SECTORCOUNT 	0x00000001
+ #define	ERROR_DISK_NOTAVAILABLE		0x00000002
+ #define	ERROR_INVALID_CHANNEL		0x00000003
+ 
+ #define		MAXBOARD				4
+ 
+ #define	NORMALSTATUS				0x00000000
+ #define DISKSWAPPED					0x00000001
+ #define MIRRORDISABLED				0x00000002
+ #define REBUILDING					0x00000010
+ #define	REBUILDED					0x00000020
+ #define	DISKNOTAVAILABLE			0x80000000
+ 
+ extern int        	ultima_detect( Scsi_Host_Template * );
+ extern int        	ultima_release( struct Scsi_Host * tpnt);
+ extern int        	ultima_command( Scsi_Cmnd * );
+ extern int        	ultima_queue( Scsi_Cmnd *, void (*done)(Scsi_Cmnd *) );
+ extern int        	ultima_abort( Scsi_Cmnd * );
+ extern int        	ultima_reset( Scsi_Cmnd *, unsigned int ); 
+ extern int        	ultima_biosparam( Disk *, kdev_t, int * );
+ extern int        	ultima_handle( Scsi_Cmnd * );
+ extern char * 		ultima_info( struct Scsi_Host * );
+ extern int		ultima_cardreset( void );
+ extern int        	ultima_proc_info( char *buffer, char **start, off_t offset,
+ 				   					int length, int hostno, int inout );
+ 
+ extern struct proc_dir_entry proc_scsi_aralion;
+ 
+ #define ULTIMA_REVID "Aralion ATA133 IDE Raid Controller driver; Revision: LH1.00BCS"
+ 
+ #define ULTIMA_DMA133 { 										\
+ 			next:		NULL,						\
+ 			module:		NULL,						\
+ 			proc_dir: 	NULL,						\
+ 			proc_name:	"Aralion", \
+ 			proc_info:     		ultima_proc_info,           \
+ 			name: "Ultima RAID 133",						\
+ 			detect:    			ultima_detect,              \
+ 			release: 			ultima_release,				\
+ 			info	:			NULL,	\
+ 			ioctl:				NULL,				\
+ 		    command:        	NULL,             \
+ 		    queuecommand:   	ultima_queue,               \
+ 		    abort:          	ultima_abort,               \
+ 			reset:				ultima_reset,				\
+ 			slave_attach:		NULL, \
+ 		    bios_param:     	ultima_biosparam,           \
+ 		    can_queue:      	1, 			 				\
+ 		    this_id:        	15, 			 			\
+ 			present:	0, \
+ 		    sg_tablesize:   	16, 			 			\
+ 			cmd_per_lun: 		0,		/* cmds per lun		      */\
+ 		    use_clustering: 	DISABLE_CLUSTERING, 			\
+     		use_new_eh_code: 	0};						
+ 
+ typedef struct 
+ {
+  char *buffer;
+  unsigned long bufferlen;
+ } IoctlParam;
+ 
+ typedef struct
+ {
+ 	char signature[8];
+ 	unsigned long IOPort1;
+ 	unsigned long irq;
+ } IrqID;
+ 
+ typedef struct {
+ 	DWORD	BoardID;
+ 	DWORD	Channel;
+ 	DWORD	Drive;	
+ 	DWORD	Size;
+ } DISKLIST;
+ 
+ typedef struct {
+ 	DWORD		RaidStatus;
+ 	DISKLIST	DiskStatus;
+ } _DiskIDTable;
+ 
+ typedef struct _PDT_TABLE {
+ 	ULONG  address;   
+ 	USHORT length;   
+ 	UCHAR  Reserved;
+ 	UCHAR  EndOfChain;
+ } PDT_TABLE, *PPDT_TABLE;
+ 
+ typedef struct
+ {
+ 	PDT_TABLE	ScatterList[128];
+ 	ULONG		ListCount;
+ 	ULONG		NumSectors;
+ 	ULONG		StartLba;
+ 	ULONG		InterruptFlag;
+ } DISKRWINFO;
+ 
+ typedef struct _BOARDTABLE {
+     ULONG 		PrimaryIO;
+     ULONG 		SecondaryIO;
+ 	ULONG 		PrimaryDmaIO;
+ 	ULONG 		SecondaryDmaIO;
+ 	ULONG 		ControlRegister;
+ 	ULONG		FlashMemory;
+ 	ULONG 		interrupt_level;
+ 	
+ 	PPDT_TABLE	PriScatterList;
+ 	PPDT_TABLE	SecScatterList;
+ 
+ 	ULONG		ListCount;
+ 	ULONG		NumSectors;
+ 	ULONG		StartLba;
+ 	ULONG		InterruptFlag[2];
+ } BOARDTABLE,*PBOARDsTABLE;
+ 
+ typedef struct _V6BDISKINFO
+ {
+ 	UCHAR Mode;
+ 	UCHAR PhysicalDrive;
+ 	UCHAR Order;
+ }V6BDISKINFO,*PV6BDISK;
+ 
+ typedef struct _V6InterfaceB
+ {
+ 	ULONG TagField;
+ 	USHORT Version;
+ 	UCHAR Reserved;
+ 	UCHAR StructSize;
+ 	USHORT RebuildBit;
+ 	UCHAR Mode;
+ 	UCHAR IsSafeMode;
+ 	ULONG Reserved1;
+ 	ULONG BaseHddSize[8];
+ 	V6BDISKINFO DiskInfo[4][4];
+ 	UCHAR Reserved2[5];
+ 	UCHAR ProcInfo[4];
+ 	UCHAR Reserved3[151];
+ }V6INTERFACEB,*PV6INTERFACEB;
+ 
+ #define GetStatus(BaseIoAddress, Status) Status = inb((BaseIoAddress) + AlternateStatusPort);
+ 
+ #define GetBaseStatus(BaseIoAddress, Status) \
+ 	    Status = inb(BaseIoAddress + CommandPort);
+ 
+ #define Delayed_Time(delay) { \
+ 	ULONG j = jiffies + delay * HZ; \
+ 	struct wait_queue *wait = NULL; \
+ 	current->timeout = j; \
+ 	interruptible_sleep_on(&wait); }
+ 
+ #define WaitOnBusy(BaseIoAddress, Status) {ULONG i; \
+ 	for (i=0; i<5; i++) { \
+ 		GetStatus((BaseIoAddress), Status); \
+ 			if (Status & IDE_STATUS_BUSY) { \
+ 				udelay(1); \
+ 				continue; \
+ 			} else { \
+ 				break; \
+ 			} \
+ 	} \
+ }
+ 
+ #define WaitForDrq(BaseIoAddress, Status) \
+ { \
+ 	ULONG i; \
+ 	for (i=0; i<1000; i++) { \
+ 		GetStatus(BaseIoAddress, Status); \
+ 			if (Status & IDE_STATUS_BUSY) { \
+ 				udelay(150); \
+ 			} else if (Status & IDE_STATUS_DRQ) { \
+ 				break; \
+ 			} else { \
+ 				udelay(200); \
+ 			} \
+ 	} \
+ }
+ 
+ #endif
+ #define SelectFirstChannel(BoardID) outb(0xA0,BoardInfo[BoardID].SecondaryIO+DriveSelectPort);
+ #define SelectSecondChannel(BoardID) outb(0xB0,BoardInfo[BoardID].SecondaryIO+DriveSelectPort);
+ 	
